/// <reference types="@swagger-api/apidom-core/types/minim" />
import * as _swagger_api_apidom_core from '@swagger-api/apidom-core';
import { MediaTypes, NamespacePluginOptions, StringElement, Element, Meta, Attributes, NumberElement, BooleanElement, ArrayElement } from '@swagger-api/apidom-core';
export { isArrayElement, isBooleanElement, isElement, isLinkElement, isMemberElement, isNullElement, isNumberElement, isObjectElement, isRefElement, isStringElement } from '@swagger-api/apidom-core';
import * as minim from 'minim';
import * as stampit from 'stampit';
import { JSONSchemaElement, JSONReferenceElement, LinkDescriptionElement } from '@swagger-api/apidom-ns-json-schema-draft-4';
export { AlternatingVisitor, FallbackVisitor, FixedFieldsVisitor, JSONReferenceElement, MapVisitor, MediaElement, ParentSchemaAwareVisitor, PatternedFieldsVisitor, SpecificationVisitor, isJSONReferenceElement, isJSONReferenceLikeElement, isMediaElement } from '@swagger-api/apidom-ns-json-schema-draft-4';

type Format = 'generic' | 'json' | 'yaml';
declare class JSONSchemaDraft6MediaTypes extends MediaTypes<string> {
    filterByFormat(format?: Format): string[];
    findBy(version?: string, format?: Format): string;
    latest(format?: Format): string;
}
declare const mediaTypes: JSONSchemaDraft6MediaTypes;

declare const jsonSchemaDraft6: {
    namespace: (options: NamespacePluginOptions) => minim.Namespace;
};

declare const plugin: () => () => {
    visitor: {
        StringElement(element: StringElement, key: any, parent: any, path: any, ancestors: any[]): any;
    };
};

declare const refract: <T extends Element>(value: any, { specPath, plugins, specificationObj, }?: {
    specPath?: string[] | undefined;
    plugins?: never[] | undefined;
    specificationObj?: {
        visitors: {
            value: stampit.default.Stamp<any>;
            JSONSchemaOrJSONReferenceVisitor: stampit.default.Stamp<any>;
            document: {
                objects: {
                    JSONSchema: {
                        $visitor: stampit.default.Stamp<any>;
                        fixedFields: {
                            id: stampit.default.Stamp<any>;
                            $schema: stampit.default.Stamp<any>;
                            multipleOf: stampit.default.Stamp<any>;
                            maximum: stampit.default.Stamp<any>;
                            exclusiveMaximum: stampit.default.Stamp<any>;
                            minimum: stampit.default.Stamp<any>;
                            exclusiveMinimum: stampit.default.Stamp<any>;
                            maxLength: stampit.default.Stamp<any>;
                            minLength: stampit.default.Stamp<any>;
                            pattern: stampit.default.Stamp<any>;
                            additionalItems: stampit.default.Stamp<any>;
                            items: stampit.default.Stamp<any>;
                            maxItems: stampit.default.Stamp<any>;
                            minItems: stampit.default.Stamp<any>;
                            uniqueItems: stampit.default.Stamp<any>;
                            maxProperties: stampit.default.Stamp<any>;
                            minProperties: stampit.default.Stamp<any>;
                            required: stampit.default.Stamp<any>;
                            properties: stampit.default.Stamp<any>;
                            additionalProperties: stampit.default.Stamp<any>;
                            patternProperties: stampit.default.Stamp<any>;
                            dependencies: stampit.default.Stamp<any>;
                            enum: stampit.default.Stamp<any>;
                            type: stampit.default.Stamp<any>;
                            allOf: stampit.default.Stamp<any>;
                            anyOf: stampit.default.Stamp<any>;
                            oneOf: stampit.default.Stamp<any>;
                            not: stampit.default.Stamp<any>;
                            definitions: stampit.default.Stamp<any>;
                            title: stampit.default.Stamp<any>;
                            description: stampit.default.Stamp<any>;
                            default: stampit.default.Stamp<any>;
                            format: stampit.default.Stamp<any>;
                            base: stampit.default.Stamp<any>;
                            links: stampit.default.Stamp<any>;
                            media: {
                                $ref: string;
                            };
                            readOnly: stampit.default.Stamp<any>;
                        };
                    };
                    JSONReference: {
                        $visitor: stampit.default.Stamp<any>;
                        fixedFields: {
                            $ref: stampit.default.Stamp<any>;
                        };
                    };
                    Media: {
                        $visitor: stampit.default.Stamp<any>;
                        fixedFields: {
                            binaryEncoding: stampit.default.Stamp<any>;
                            type: stampit.default.Stamp<any>;
                        };
                    };
                    LinkDescription: {
                        $visitor: stampit.default.Stamp<any>;
                        fixedFields: {
                            href: stampit.default.Stamp<any>;
                            rel: stampit.default.Stamp<any>;
                            title: stampit.default.Stamp<any>;
                            targetSchema: stampit.default.Stamp<any>;
                            mediaType: stampit.default.Stamp<any>;
                            method: stampit.default.Stamp<any>;
                            encType: stampit.default.Stamp<any>;
                            schema: stampit.default.Stamp<any>;
                        };
                    };
                };
            };
        };
    } | undefined;
}) => T;
declare const createRefractor: (specPath: string[]) => (value: any, options?: {}) => Element;

declare const _default: {
    visitors: {
        value: stampit.default.Stamp<any>;
        JSONSchemaOrJSONReferenceVisitor: stampit.default.Stamp<any>;
        document: {
            objects: {
                JSONSchema: {
                    $visitor: stampit.default.Stamp<any>;
                    fixedFields: {
                        id: stampit.default.Stamp<any>;
                        $schema: stampit.default.Stamp<any>;
                        multipleOf: stampit.default.Stamp<any>;
                        maximum: stampit.default.Stamp<any>;
                        exclusiveMaximum: stampit.default.Stamp<any>;
                        minimum: stampit.default.Stamp<any>;
                        exclusiveMinimum: stampit.default.Stamp<any>;
                        maxLength: stampit.default.Stamp<any>;
                        minLength: stampit.default.Stamp<any>;
                        pattern: stampit.default.Stamp<any>;
                        additionalItems: stampit.default.Stamp<any>;
                        items: stampit.default.Stamp<any>;
                        maxItems: stampit.default.Stamp<any>;
                        minItems: stampit.default.Stamp<any>;
                        uniqueItems: stampit.default.Stamp<any>;
                        maxProperties: stampit.default.Stamp<any>;
                        minProperties: stampit.default.Stamp<any>;
                        required: stampit.default.Stamp<any>;
                        properties: stampit.default.Stamp<any>;
                        additionalProperties: stampit.default.Stamp<any>;
                        patternProperties: stampit.default.Stamp<any>;
                        dependencies: stampit.default.Stamp<any>;
                        enum: stampit.default.Stamp<any>;
                        type: stampit.default.Stamp<any>;
                        allOf: stampit.default.Stamp<any>;
                        anyOf: stampit.default.Stamp<any>;
                        oneOf: stampit.default.Stamp<any>;
                        not: stampit.default.Stamp<any>;
                        definitions: stampit.default.Stamp<any>;
                        title: stampit.default.Stamp<any>;
                        description: stampit.default.Stamp<any>;
                        default: stampit.default.Stamp<any>;
                        format: stampit.default.Stamp<any>;
                        base: stampit.default.Stamp<any>;
                        links: stampit.default.Stamp<any>;
                        media: {
                            $ref: string;
                        };
                        readOnly: stampit.default.Stamp<any>;
                    };
                };
                JSONReference: {
                    $visitor: stampit.default.Stamp<any>;
                    fixedFields: {
                        $ref: stampit.default.Stamp<any>;
                    };
                };
                Media: {
                    $visitor: stampit.default.Stamp<any>;
                    fixedFields: {
                        binaryEncoding: stampit.default.Stamp<any>;
                        type: stampit.default.Stamp<any>;
                    };
                };
                LinkDescription: {
                    $visitor: stampit.default.Stamp<any>;
                    fixedFields: {
                        href: stampit.default.Stamp<any>;
                        rel: stampit.default.Stamp<any>;
                        title: stampit.default.Stamp<any>;
                        targetSchema: stampit.default.Stamp<any>;
                        mediaType: stampit.default.Stamp<any>;
                        method: stampit.default.Stamp<any>;
                        encType: stampit.default.Stamp<any>;
                        schema: stampit.default.Stamp<any>;
                    };
                };
            };
        };
    };
};

declare class JSONSchema extends JSONSchemaElement {
    constructor(content?: Record<string, unknown>, meta?: Meta, attributes?: Attributes);
    /**
     * Core vocabulary
     *
     * URI: https://datatracker.ietf.org/doc/html/draft-wright-json-schema-01
     */
    get idProp(): StringElement | undefined;
    set idProp(id: StringElement | undefined);
    get $id(): StringElement | undefined;
    set $id($id: StringElement | undefined);
    /**
     * Validation vocabulary
     *
     * URI: https://datatracker.ietf.org/doc/html/draft-wright-json-schema-validation-01
     */
    /**
     *  Validation keywords for numeric instances (number and integer)
     */
    get exclusiveMaximum(): NumberElement | undefined;
    set exclusiveMaximum(exclusiveMaximum: NumberElement | undefined);
    get exclusiveMinimum(): NumberElement | undefined;
    set exclusiveMinimum(exclusiveMinimum: NumberElement | undefined);
    /**
     * Validation keywords for arrays
     */
    get containsProp(): this | BooleanElement | JSONReferenceElement | undefined;
    set containsProp(contains: this | BooleanElement | JSONReferenceElement | undefined);
    get items(): this | BooleanElement | JSONReferenceElement | ArrayElement | undefined | any;
    set items(items: this | BooleanElement | JSONReferenceElement | ArrayElement | undefined | any);
    /**
     * Validation keywords for objects
     */
    get propertyNames(): this | BooleanElement | JSONReferenceElement | undefined;
    set propertyNames(propertyNames: this | BooleanElement | JSONReferenceElement | undefined);
    /**
     *  Validation keywords for any instance type
     */
    get const(): Element | undefined;
    set const(constValue: Element | undefined);
    get not(): this | BooleanElement | JSONReferenceElement | undefined | any;
    set not(not: this | BooleanElement | JSONReferenceElement | undefined | any);
    /**
     * Metadata keywords
     *
     * URI: https://datatracker.ietf.org/doc/html/draft-wright-json-schema-validation-01#section-7
     */
    get examples(): ArrayElement | undefined;
    set examples(examples: ArrayElement | undefined);
}

/**
 * URI: https://datatracker.ietf.org/doc/html/draft-wright-json-schema-hyperschema-01#section-6
 */
declare class LinkDescription extends LinkDescriptionElement {
    get hrefSchema(): JSONSchema | BooleanElement | JSONReferenceElement | undefined;
    set hrefSchema(hrefSchema: JSONSchema | BooleanElement | JSONReferenceElement | undefined);
    get targetSchema(): JSONSchema | BooleanElement | JSONReferenceElement | undefined | any;
    set targetSchema(targetSchema: JSONSchema | BooleanElement | JSONReferenceElement | undefined | any);
    get schema(): JSONSchema | JSONReferenceElement | undefined;
    set schema(schema: JSONSchema | JSONReferenceElement | undefined);
    get submissionSchema(): JSONSchema | BooleanElement | JSONReferenceElement | undefined;
    set submissionSchema(submissionSchema: JSONSchema | BooleanElement | JSONReferenceElement | undefined);
    get method(): StringElement | undefined;
    set method(method: StringElement | undefined);
    get encType(): StringElement | undefined;
    set encType(encType: StringElement | undefined);
    get submissionEncType(): StringElement | undefined;
    set submissionEncType(submissionEncType: StringElement | undefined);
}

declare const isJSONSchemaElement: _swagger_api_apidom_core.ElementPredicate<JSONSchema>;
declare const isLinkDescriptionElement: _swagger_api_apidom_core.ElementPredicate<LinkDescription>;

declare const getNodeType: <T extends Element>(element: T) => string | undefined;
declare const keyMap: {
    ObjectElement: string[];
    ArrayElement: string[];
    MemberElement: string[];
    StringElement: never[];
    BooleanElement: never[];
    NumberElement: never[];
    NullElement: never[];
    RefElement: never[];
    LinkElement: never[];
    Annotation: never[];
    Comment: never[];
    ParseResultElement: string[];
    SourceMap: string[];
    JSONSchemaDraft6Element: string[];
    JSONReferenceElement: string[];
    MediaElement: string[];
    LinkDescriptionElement: string[];
};

export { JSONSchemaDraft6MediaTypes, JSONSchema as JSONSchemaElement, LinkDescription as LinkDescriptionElement, createRefractor, jsonSchemaDraft6 as default, getNodeType, isJSONSchemaElement, isLinkDescriptionElement, keyMap, mediaTypes, refract, plugin as refractorPluginReplaceEmptyElement, _default as specificationObj };
